"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function hasColumnConstraint({ constraints }, type) {
    if (!constraints)
        return false;
    return !!constraints.find(({ constraintType }) => constraintType === type);
}
exports.hasColumnConstraint = hasColumnConstraint;
function isDataTypeInteger(colType) {
    return colType === "int" || colType === "integer" || colType === "bigint" || colType === "smallint"
        || colType === "tinyint";
}
exports.isDataTypeInteger = isDataTypeInteger;
function isDataTypeNumber(colType) {
    return colType === "float" || colType === "real" || colType === "decimal" || colType === "numeric"
        || isDataTypeInteger(colType);
}
exports.isDataTypeNumber = isDataTypeNumber;
function isDataTypeString(colType) {
    return colType === "char" || colType === "varchar" || colType === "text";
}
exports.isDataTypeString = isDataTypeString;
function isDataTypeDateOrTime(colType) {
    return colType === "date" || colType === "time" || colType === "timestamp" || colType === "datetime";
}
exports.isDataTypeDateOrTime = isDataTypeDateOrTime;
