"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function foreignKeyAlwaysWithReferencedColumns() {
    let currentColumnName;
    return [
        {
            forEach: "foreignKeyTableConstraint",
            replace(fk) {
                if (fk.referencedColumns)
                    return fk;
                return Object.assign(Object.assign({}, fk), { referencedColumns: [...fk.columns] });
            }
        },
        {
            forEach: "column",
            listen(column) {
                currentColumnName = column.name;
            }
        },
        {
            forEach: "foreignKeyColumnConstraint",
            replace(fk) {
                if (currentColumnName === undefined)
                    throw new Error(`Missing current column name`);
                if (fk.referencedColumn)
                    return fk;
                console.log("-->", currentColumnName);
                return Object.assign(Object.assign({}, fk), { referencedColumn: currentColumnName });
            }
        },
    ];
}
exports.foreignKeyAlwaysWithReferencedColumns = foreignKeyAlwaysWithReferencedColumns;
