"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ast_helpers_1 = require("../ast-helpers");
const gen_helpers_1 = require("./gen-helpers");
const universal_ddl_generator_1 = require("./universal-ddl-generator");
function makeSqliteDdlGeneratorContext(options) {
    const sections = Object.assign(Object.assign({}, universal_ddl_generator_1.universalDdlSections), { tableEntries: Object.assign(Object.assign({}, universal_ddl_generator_1.universalDdlSections.tableEntries), { column(cx, node) {
                if (!ast_helpers_1.hasColumnConstraint(node, "autoincrement") || node.type === "integer")
                    return universal_ddl_generator_1.universalDdlSections.tableEntries.column(cx, node);
                if (!ast_helpers_1.isDataTypeInteger(node.type)) {
                    throw new Error(`Constraint 'autoincrement' on column '${node.name}' should be used with an 'integer' data type` +
                        ` (current: '${node.type}') with SQLite`);
                }
                const type = "integer";
                let constraints = cx.gen("columnChildren", "constraints", node.constraints || []).code;
                constraints = constraints ? ` ${constraints}` : "";
                return {
                    lines: [
                        universal_ddl_generator_1.toCodeBlockComment(node.blockComment),
                        {
                            code: `${node.name} ${type}${constraints}`,
                            inlineComment: universal_ddl_generator_1.normalizeInlineComment(node.inlineComment)
                        },
                    ]
                };
            } }) });
    return gen_helpers_1.makeGeneratorContext(options, sections);
}
exports.makeSqliteDdlGeneratorContext = makeSqliteDdlGeneratorContext;
