"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Helper for ANTLR4.
 * @param ctx A `ParseTree` instance: of type `TerminalNode` or `RuleContext`.
 */
function ruleNameOf(ctx) {
    if (isAntlrRuleContext(ctx))
        return ctx.parser.ruleNames[ctx.ruleIndex];
    else if (isAntlrTerminalNode(ctx))
        return ctx.parentCtx.parser.symbolicNames[ctx.symbol.type];
}
exports.ruleNameOf = ruleNameOf;
function isAntlrRuleContext(ctx) {
    return !!ctx["parser"] && ctx["ruleIndex"] !== undefined;
}
exports.isAntlrRuleContext = isAntlrRuleContext;
function isAntlrTerminalNode(ctx) {
    return !!ctx["parentCtx"] && !!ctx["symbol"];
}
exports.isAntlrTerminalNode = isAntlrTerminalNode;
